package ru.ab.lab.jmix.jobs;

import org.quartz.CronScheduleBuilder;
import org.quartz.JobBuilder;
import org.quartz.JobDetail;
import org.quartz.Trigger;
import org.quartz.TriggerBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.Date;

@Configuration
public class JobsConfig {

    public static final String JOB_TRIGGER_NAME = "testJobTrigger";
    public static final String JOB_NAME = "testJob";
    public static final String JOB_GROUP = "testJobGroup";

    @Bean
    Trigger testJobTriggerTrigger() {
        Date now = new Date();
        Date afterTenSeconds = new Date(now.getTime() + 10000);
        return TriggerBuilder.newTrigger()
                .withIdentity(JOB_TRIGGER_NAME)
                .forJob(testJob())
                .startAt(afterTenSeconds)
                .startNow()
                .withSchedule(CronScheduleBuilder.cronSchedule("0/10 * * * * ?"))
                .build();
    }

    @Bean
    JobDetail testJob() {
        return JobBuilder.newJob()
                .ofType(TestJob.class)
                .storeDurably()
                .withIdentity(JOB_NAME, JOB_GROUP)
                .build();
    }
}