package ru.ab.lab.jmix.jobs;

import io.jmix.core.security.Authenticated;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobDataMap;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.PersistJobDataAfterExecution;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.transaction.annotation.Transactional;

import java.time.OffsetDateTime;
import java.time.format.DateTimeFormatter;

@DisallowConcurrentExecution
@PersistJobDataAfterExecution
public class TestJob implements Job {

    private static final Logger log = LoggerFactory.getLogger(TestJob.class);

    @Authenticated
    @Transactional
    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {

        JobDataMap dataMap = context.getJobDetail().getJobDataMap();
        String prevSyncDate = dataMap.getString("syncDate");

        log.info("RUN TestJob {prevSyncDate: {}...}", prevSyncDate);

        OffsetDateTime now = OffsetDateTime.now();
        String strNow = DateTimeFormatter.ISO_DATE_TIME.format(now);

        doSomething();

        dataMap.put("syncDate", strNow);
    }

    private void doSomething() {
    }
}